glibmm: Gio::SimplePermission Class Reference

glibmm 2.89.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::SimplePermission Class Reference

A Permission that doesn't change value. More...

`#include <giomm/simplepermission.h>`

Inheritance diagram for Gio::SimplePermission:
[legend]

## Public Member Functions
| SimplePermission (SimplePermission && src) noexcept
SimplePermission & | operator= (SimplePermission && src) noexcept
| ~SimplePermission () noexcept override
GSimplePermission * | gobj ()
| Provides access to the underlying C GObject.
const GSimplePermission * | gobj () const
| Provides access to the underlying C GObject.
GSimplePermission * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Public Member Functions inherited from Gio::Permission
| Permission (Permission && src) noexcept
Permission & | operator= (Permission && src) noexcept
| ~Permission () noexcept override
GPermission * | gobj ()
| Provides access to the underlying C GObject.
const GPermission * | gobj () const
| Provides access to the underlying C GObject.
GPermission * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | acquire (const Glib::RefPtr< Cancellable > & cancellable)
| Attempts to acquire the permission represented by permission.
bool | acquire ()
| A acquire() convenience overload.
void | acquire_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable)
| Attempts to acquire the permission represented by permission.
void | acquire_async (const SlotAsyncReady & slot)
| A acquire_async() convenience overload.
bool | acquire_finish (const Glib::RefPtr< AsyncResult > & result)
| Collects the result of attempting to acquire the permission represented by permission.
bool | release (const Glib::RefPtr< Cancellable > & cancellable)
| Attempts to release the permission represented by permission.
bool | release ()
| A release() convenience overload.
void | release_async (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable)
| Attempts to release the permission represented by permission.
void | release_async (const SlotAsyncReady & slot)
| A release_async() convenience overload.
bool | release_finish (const Glib::RefPtr< AsyncResult > & result)
| Collects the result of attempting to release the permission represented by permission.
bool | get_allowed () const
| Gets the value of the 'allowed' property.
bool | get_can_acquire () const
| Gets the value of the 'can-acquire' property.
bool | get_can_release () const
| Gets the value of the 'can-release' property.
Glib::PropertyProxy_ReadOnly< bool > | property_allowed () const
| true if the caller currently has permission to perform the action that permission represents the permission to perform.
Glib::PropertyProxy_ReadOnly< bool > | property_can_acquire () const
| true if it is generally possible to acquire the permission by calling g_permission_acquire().
Glib::PropertyProxy_ReadOnly< bool > | property_can_release () const
| true if it is generally possible to release the permission by calling g_permission_release().
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
void * | get_data (const QueryQuark & key)
void | set_data (const Quark & key, void *data)
void | set_data_with_c_callback (const Quark & key, void *data, GDestroyNotify notify)
void | set_data (const Quark & key, void *data, DestroyNotify notify)
| Prefer set_data_with_c_callback() with a callback with C linkage.
void | remove_data (const QueryQuark & quark)
void * | steal_data (const QueryQuark & quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring & property_name, const Glib::ValueBase & value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring & property_name, Glib::ValueBase & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | set_property (const Glib::ustring & property_name, const PropertyType & value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
void | get_property (const Glib::ustring & property_name, PropertyType & value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType>
PropertyType | get_property (const Glib::ustring & property_name) const
| You probably want to use a specific property_*() accessor method instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, const sigc::slot< void()> & slot)
| You can use the signal_changed() signal of the property proxy instead.
sigc::connection | connect_property_changed (const Glib::ustring & property_name, sigc::slot< void()> && slot)
| You can use the signal_changed() signal of the property proxy instead.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject * | gobj ()
| Provides access to the underlying C GObject.
const GObject * | gobj () const
| Provides access to the underlying C GObject.
GObject * | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< SimplePermission > | create (bool allowed)
Static Public Member Functions inherited from Gio::Permission
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Protected Member Functions
| SimplePermission (bool allowed)
Protected Member Functions inherited from Gio::Permission
| Permission ()
virtual bool | acquire_vfunc (const Glib::RefPtr< Cancellable > & cancellable)
virtual void | acquire_async_vfunc (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable)
virtual bool | acquire_finish_vfunc (const Glib::RefPtr< AsyncResult > & result)
virtual bool | release_vfunc (const Glib::RefPtr< Cancellable > & cancellable)
virtual void | release_async_vfunc (const SlotAsyncReady & slot, const Glib::RefPtr< Cancellable > & cancellable)
virtual bool | release_finish_vfunc (const Glib::RefPtr< AsyncResult > & result)
void | impl_update (bool allowed, bool can_acquire, bool can_release)
| This function is called by the Permission implementation to update the properties of the permission.
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams & construct_params)
| Object (GObject * castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char * custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info & custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
| ObjectBase (ObjectBase && src) noexcept
ObjectBase & | operator= (ObjectBase && src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject * castitem)
void | initialize_move (GObject * castitem, Glib::ObjectBase * previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::SimplePermission > | wrap (GSimplePermission * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gio::Permission
Glib::RefPtr< Gio::Permission > | wrap (GPermission * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject * object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void (*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A Permission that doesn't change value.

SimplePermission is a trivial implementation of Permission that represents a permission that is either always or never allowed. The value is given at construction and doesn't change.

Calling Permission::acquire() or Permission::release() will result in errors.

## Constructor & Destructor Documentation

## ◆ SimplePermission() [1/2]

Gio::SimplePermission::SimplePermission | ( | SimplePermission && | src | ) |
| noexcept

## ◆ ~SimplePermission()

Gio::SimplePermission::~SimplePermission | ( |  | ) |
| overridenoexcept

## ◆ SimplePermission() [2/2]

Gio::SimplePermission::SimplePermission | ( | bool | allowed | ) |
| explicitprotected

## Member Function Documentation

## ◆ create()

Glib::RefPtr< SimplePermission > Gio::SimplePermission::create | ( | bool | allowed | ) |
| static

## ◆ get_type()

GType Gio::SimplePermission::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GSimplePermission * Gio::SimplePermission::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GSimplePermission * Gio::SimplePermission::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GSimplePermission * Gio::SimplePermission::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

SimplePermission & Gio::SimplePermission::operator= | ( | SimplePermission && | src | ) |
| noexcept

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::SimplePermission > wrap | ( | GSimplePermission * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.